/**********************************************************************/
/* The 1st IPSJ SIG-ARC High-Performance Processor Design Contest     */
/* 320mm Version 2013-10-13                                           */
/**********************************************************************/
#include "../../lib/lib.c"

/**********************************************************************/
volatile int *init_data = (int*)0x00040000;
volatile int *init_n    = (int*)0x0007fffc;

/**********************************************************************/
int main(void) {
    
    int n = *init_n;

    mylib_display_char('m');
    mylib_display_char('m');
    mylib_display_char(' ');
    mylib_display_char('n');
    mylib_display_char('=');
    mylib_display_dec(n);
    mylib_display_newline();
    
    int *a = (int*)0x100000;
    int *b = (int*)0x200000;
    int *c = (int*)0x300000;

    int y,x,i;
    
    /* ----- Initialize ----- */
    int d = 0;
    for(y=0; y<n; y++) {
        for(x=0; x<n; x++) {
            a[n*y+x] = init_data[d     % (64*1024)];
            b[n*y+x] = init_data[(d+1) % (64*1024)];
            c[n*y+x] = 0;
            d +=2;
        }
    }
    
    /* -----  main kernel ----- */ 
    for(y = 0; y < n; y++) {
        for(x = 0; x < n; x++) {
            for(i = 0; i < n; i++) {
                c[n*y+x] += a[n*y+i] * b[n*i+x];
            }
        }
    }

    /* -----  show result ----- */
    mylib_display_newline();
    for(y = n-8; y<n; y++) {
        for(x = n-8; x<n; x++) {
            mylib_display_hex(c[n*y+x]);
            mylib_display_char(' ');
        }
        mylib_display_newline();
    }
    int sum = 0;
    for(y = 0; y < n; y++) {
        for(x = 0; x < n; x++) {
            sum += c[n*y+x];
        }
    }
    mylib_display_hex(sum); // check sum
    mylib_display_newline();
    
    mylib_finalize();
    return 0;
}
/**********************************************************************/
